%global maven_version 0.9.1.redhat-1
%global maven_repo_dir %{_javadir}/maven-repo
%global __jar_repack 0

Name: qpid-proton-java
Version:        0.9.1
Release:        2%{?dist}
License:         ASL 2.0
Summary: A library for speaking AMQP
Group: Development/Java
URL: http://qpid.apache.org/proton/
Source0: proton-j-0.9.1.redhat-1.pom
Source1: proton-j-0.9.1.redhat-1.jar
Source2: proton-j-messenger-example-0.9.1.redhat-1.jar
Source3: proton-j-messenger-example-0.9.1.redhat-1.pom
Source4: proton-jms-0.9.1.redhat-1.jar
Source5: proton-jms-0.9.1.redhat-1.pom
Source6: proton-hawtdispatch-0.9.1.redhat-1.jar
Source7: proton-hawtdispatch-0.9.1.redhat-1.pom
Source9: apache-qpid-proton-j-0.9.1.redhat-1.pom
Source10: proton-tests-0.9.1.redhat-1.pom
Source11: proton-tests-0.9.1.redhat-1.jar
Source13: proton-project-0.9.1.redhat-1.pom
Source100:       proton-project-0.9.1.redhat-1-scm-sources.zip 
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: noarch

%description
Proton is a library for speaking AMQP.

%package maven-repo
Summary:        Maven repository for qpid proton-j
Group:          Development/Java

%description maven-repo
Maven repository for qpid proton-j

%prep
#%setup -q -T -b 100 -n apache-log4j-%{version}
%setup -q -T -b 100 -n rh-qpid-proton

%build

%install
rm -rf %{buildroot}

function maven_checksums() {
  local FILEPATH=$1
  local DESTFILE=$2
  if [ -z "$DESTFILE" ]; then
    DESTFILE=$FILEPATH
  fi
  md5sum $FILEPATH | cut -d' ' -f1 > $DESTFILE.md5
  sha1sum $FILEPATH | cut -d' ' -f1 > $DESTFILE.sha1
}

function populate_maven_repo() {
  local POMPATH=$1
  local POMDIR=${POMPATH%/*}
  local POMFILE=${POMPATH##*/}
  local JARBASE=${POMFILE%.pom}
  local PARENTDIR=${POMDIR%/*}
  local ARTIFACTID=${PARENTDIR##*/}

  if [ "$ARTIFACTID" == "proton-j" ]; then :;
  elif [ "$ARTIFACTID" == "proton-project" ]; then :;
  else
    return 0
  fi
  
  %{__mkdir_p} %{buildroot}%{maven_repo_dir}/$POMDIR
  %{__install} -pm 644 %{_sourcedir}/$POMFILE \
                       %{buildroot}%{maven_repo_dir}/$POMDIR
  maven_checksums %{buildroot}%{maven_repo_dir}/$POMDIR/$POMFILE
  local VERSION=${POMDIR##*/}
  local GROUPPATH=${PARENTDIR%/*}
  local GROUPID=${GROUPPATH//\//.}
  cat > %{buildroot}%{maven_repo_dir}/$PARENTDIR/maven-metadata.xml <<EOF
<metadata>
  <groupId>$GROUPID</groupId>
  <artifactId>$ARTIFACTID</artifactId>
  <versioning>
    <release>$VERSION</release>
    <versions>
      <version>$VERSION</version>
    </versions>
    <lastUpdated>$(date +%%Y%%m%%d%%H%%M%%S)</lastUpdated>
  </versioning>
</metadata>
EOF
  maven_checksums %{buildroot}%{maven_repo_dir}/$PARENTDIR/maven-metadata.xml
  for jarpath in %{buildroot}%{_javadir}/%{name}-%{version}/$JARBASE*.jar; do
    if [ -f $jarpath ]; then
      JARFILE=$(basename $jarpath)
      ln -s %{_javadir}/%{name}-%{version}/$JARFILE \
            %{buildroot}%{maven_repo_dir}/$POMDIR/$JARFILE
      maven_checksums %{buildroot}%{_javadir}/%{name}-%{version}/$JARFILE \
        %{buildroot}%{maven_repo_dir}/$POMDIR/$JARFILE
    fi
  done
}

%{__install} -dm 755 %{buildroot}%{_javadir}
%{__install} -dm 755 %{buildroot}%{_javadir}/%{name}-%{version}

%{__install} -pm 644 %{SOURCE1} %{buildroot}%{_javadir}/%{name}-%{version}

populate_maven_repo org/apache/qpid/proton-j/0.9.1.redhat-1/proton-j-0.9.1.redhat-1.pom
populate_maven_repo org/apache/qpid/proton-j-messenger-example/0.9.1.redhat-1/proton-j-messenger-example-0.9.1.redhat-1.pom
populate_maven_repo org/apache/qpid/proton-jms/0.9.1.redhat-1/proton-jms-0.9.1.redhat-1.pom
populate_maven_repo org/apache/qpid/proton-hawtdispatch/0.9.1.redhat-1/proton-hawtdispatch-0.9.1.redhat-1.pom
populate_maven_repo org/apache/qpid/apache-qpid-proton-j/0.9.1.redhat-1/apache-qpid-proton-j-0.9.1.redhat-1.pom
populate_maven_repo org/apache/qpid/proton-tests/0.9.1.redhat-1/proton-tests-0.9.1.redhat-1.pom
populate_maven_repo org/apache/qpid/proton-project/0.9.1.redhat-1/proton-project-0.9.1.redhat-1.pom

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%dir %{_javadir}/%{name}-%{version}
%{_javadir}/%{name}-%{version}/*.jar
%doc LICENSE
%doc NOTICE
%doc README.md
%doc INSTALL.md

%files maven-repo
%defattr(-,root,root,-)
%{maven_repo_dir}

%changelog
* Fri May 15 2015 Irina Boverman <iboverma@redhat.com> - 0.9.1-1
- Initial build based on 0.9.1 upstream
